// // attach to firefox preference system

// var foxfm_prefObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
// var foxfm_PrefsBranch = foxfm_prefObj.getBranch("foxfm.pref.");
// alert(foxfm_PrefsBranch.getCharPref("ofm.strengthlevel.1").toUpperCase());

function exceptionHandler(err)
{
	var vDebug = "";
    for (var prop in err)
    { 
       vDebug += "property: "+ prop+ " value: ["+ err[prop]+ "]\n";
    }
    vDebug += "toString(): " + " value: [" + err.toString() + "]";
    alert(vDebug);
}

function searchTable (table, lookFor1st, lookFor2nd)
{	
	// alert("foxfm: searchTable()");
	var tableCell = new Array(-1, -1);
	//alert(lookFor1st + " " + lookFor2nd);
	rows = table.rows;
	// go through the rows
	for(var j=0; j<rows.length; j++)
	{
		cells = rows[j].cells;
		// go through the cells
		for(var k=0; k<cells.length; k++)
		{
			//alert(cells[k].innerHTML);
			cell = cells[k];
			if(cell.innerHTML.match(lookFor1st))
			{
				//alert(cell.innerHTML);	
				nextIndex = k+1;
				if(nextIndex<cells.length) 
				{
					if(cells[nextIndex].innerHTML.match(lookFor2nd)) 
					{
						//alert(cell.innerHTML);
						//alert("HIT: '" + lookFor1st + "' and '" + lookFor2nd + "' in row " + j);
						// return the row where the string was found
						tableCell[0] = j;
						tableCell[1] = k;
						return tableCell;
					}
				}	
			}
		}
	}
	return tableCell;
}

function findTable(arrayTable, strFirst, strSecond)
{
	for(var i=0; i<arrayTable.length; i++)
	{
		// get table of team --> look for "Pos" and "Spielername"
		var tableCell = searchTable(arrayTable[i], strFirst, strSecond);
		var rowIndex = tableCell[0];
		var colIndex = tableCell[1];
		// found table?
		if(rowIndex>=0)
		{
			// return index of found table
			return i;
		}
	}
	return -1;
}

// Try to find the row of the GIVEN table which contains the GIVEN
// two strings in adjacent cells and RETURN the row.
function findRow(table, strFirst, strSecond)
{
	// alert("foxfm: searchTable()");
	//alert(strFirst + " " + strSecond);
	var rows = table.rows;
	// iterate through the rows
	for(var j=0; j<rows.length; j++)
	{
		// get cells of current row
		cells = rows[j].cells;
		// iterate through the cells
		for(var k=0; k<cells.length; k++)
		{
			//alert(cells[k].innerHTML);
			cell = cells[k];
			// check if the content is first search string 'strFirst'
			if(cell.innerHTML.match(strFirst))
			{
				//alert(cell.innerHTML);	
				nextIndex = k+1;
				// check if next cell in row contains second search string 'strSecond'
				// --> found row
				if(nextIndex<cells.length) 
				{
					if(cells[nextIndex].innerHTML.match(strSecond)) 
					{
						//alert(cell.innerHTML);
						//alert("HIT: '" + lookFor1st + "' and '" + strSecond + "' in row " + j);
						// return the row where the string was found
						return j;
					}
				}	
			}
		}
	}
	// nothing was found
	return -1;
}

// Try to find the column of the GIVEN table-row which contains the GIVEN
// string and RETURN the column.
function findColumn(row, str)
{
	// alert("foxfm: searchTable()");
	// alert(row.length);
	// iterate through the rows
	for(var i=0; i<row.length; i++)
	{
		// alert(row[i].innerHTML);	
		// check if the cell in the given row contains the search string 'str'
		// --> found column
		if(row[i].innerHTML.match(str))
		{
			// alert("HIT: '" + str + "' in column " + i);
			// return the column where the string was found
			return i;
		}
	}
	// nothing was found
	return -1;
}

function addCell(tbl, row, col, content, styleClass, styleAlign, styleBgColor, attrWidth)
{
	try 
	{
		var newCell = tbl.rows[row].insertCell(col);
		newCell.innerHTML = content;
		if(styleClass != "") 
		{
			newCell.className = styleClass;
		}
		newCell.align = styleAlign;
		newCell.style.backgroundColor = styleBgColor;
		if(attrWidth)
		{
			newCell.setAttribute("width", attrWidth);
		}
	} catch(e) {
		exceptionHandler(e);
	}
}

function tableChangeAttributes(tbl, width)
{
	tbl.width =width;
}

function getNumberFromCell(cell)
{
	try
	{
		// alert("getNumberFromHtmlString(): cell.innerHTML: " + cell.innerHTML);
		num = getNumberFromString(cell.innerHTML);
		if(isNaN(num))
		{
			try 
			{
				// alert("try to get number from HTML: " + cell.getElementsByTagName("b")[0].innerHTML);
				num = getNumberFromString(cell.getElementsByTagName("b")[0].innerHTML);				
			} catch(e) {
				try
				{
					// alert("try to get number from HTML: " + cell.getElementsByTagName("strong")[0].innerHTML);
					num = getNumberFromString(cell.getElementsByTagName("strong")[0].innerHTML);					
				} catch(e) {					
					try
					{
						// alert("try to get number from HTML: " + cell.getElementsByTagName("font")[0].innerHTML);
						num = getNumberFromString(cell.getElementsByTagName("font")[0].innerHTML);
					} catch(e) {
						try
						{
							// alert("try to get number from HTML: " + cell.getElementsByTagName("div")[0].innerHTML);
							num = getNumberFromString(cell.getElementsByTagName("div")[0].innerHTML);
						} catch(e) {
							alert("Could not get the value from the HTML string: " + num);
						}
					}
				}
			}
		} 
		// alert("getNumberFromHtmlString(): return(" + num +")");
		return num;
	} catch(e) {
		exceptionHandler(e);
	}
}

function getNumberFromString (str)
{
	try
	{
		return parseFloat(str.replace(".",""));
	} catch(e) {
		exceptionHandler(e);
	}
}

function getAWP(ep, tp)
{
	return new Number(Math.round(((2*ep*tp)/(ep + tp))));
}

function getAWPs(eps, tps)
{
	var awps = new Array(eps.length);
	for(var i=0; i<eps.length; i++)
	{
		awps[i] = getAWP(eps[i], tps[i]);
	}
	return awps;
}

function getStrengthLevel(awps)
{
	for(var i=0; i<strengthPoints.length; i++)
	{
		if(awps<getNumberFromString(strengthPoints[i]))
		{
			// alert("getStrengthLevel(): return( " + i + " );");
			return i;
		}
	}
	return -1;
}

function getAWPsOfLevel(level)
{
	if(level>0)
	{
		return getNumberFromString(strengthPoints[level-1]);
	}
	return -1;
}

function addColCurrentStrength()
{
}

function addColCurrentAWPs(tbl, rowIndex, colIndex, awps)
{
	//alert(rowIndex);
	//alert(tbl.rows[rowIndex].cells[0].innerHtml);
	addCell(tbl, rowIndex, colIndex, "<a class=\"info\">AWPs<span>AWPs des Spielers</span></a>", "top", "center", "", "");
	for(var i=rowIndex+1; i<tbl.rows.length; i++) 
	{
		//alert(tbl.rows.length);
		addCell(tbl, i, colIndex, awps[i].toString(10), "", "center", "", "");
	}	
}

function addStrings(str1, str2)
{
	var s1 = parseFloat(getNumberFromString(str1));
	if (isNaN(s1)) s1 = 0;
	var s2 = parseFloat(getNumberFromString(str2));
	if (isNaN(s2)) s2 = 0;
	return (s1 + s2).toFixed(2);
}

function addCurrLvlAwpsDiffNextLvl(playerTable, headerRow, lvlCol, epCol, tpCol, awpCol, newColCurrLvl, newColAwpDiff, newColNextLvl)
{
	// alert("foxfm::addCurrLvlAwpsDiffNextLvl: newColNextLvl - " + newColNextLvl);
	if(newColCurrLvl)
	{
		addCell(playerTable, headerRow, newColCurrLvl, "<p align=center><a class=\"info\">Aktuelle<br>St&auml;rke<span>St&auml;ke des Spielers</span></a></p>", "top", "center", "", "");
	}
	if(newColAwpDiff)
	{
		addCell(playerTable, headerRow, newColAwpDiff, "<p align=center><a class=\"info\">AWPs<br>Diff<span>Differenz zur n&auml;chsten St&auml;rkestufe</span></a></p>", "top", "center", "", "");				
	}
	if(newColNextLvl)
	{
		addCell(playerTable, headerRow, newColNextLvl, "<p align=center><a class=\"info\">N&auml;chste<br>St&auml;rke<span>Die n&auml;chsten St&auml;rkestufe</span></a></p>", "top", "center", "", "");
	}
	var awp=NaN, tp=NaN, ep=NaN;

	for(var j=headerRow+1; j<playerTable.rows.length; j++)
	// for(var j=headerRow+1; j<headerRow+2; j++) // for debugging: only run throught the first row
	{		
		// alert(playerTable.rows[j].cells[awpCol].innerHTML);
		try
		{			
			// get the awp of the player - either from the given column or calculate it from TPs and EPs
			if(awpCol)
			{
				awp = getNumberFromCell(playerTable.rows[j].cells[awpCol]);
			} else {
				ep = getNumberFromCell(playerTable.rows[j].cells[epCol]);
				tp = getNumberFromCell(playerTable.rows[j].cells[tpCol]);
				awp = getAWP(ep, tp);
			}
			
			if(!isNaN(awp))
			{		
				var newCurrLvl = getStrengthLevel(awp);
				var currLvl = getNumberFromCell(playerTable.rows[j].cells[lvlCol]);
				var diffLvl = newCurrLvl - currLvl;
				// alert("addCurrLvlAwpsDiffNextLvl(): TP: " + tp + "; EP: " + ep + "; AWP: " + awp + "; CurrLvl: " + currLvl + "; new CurrentLvl: " + newCurrLvl);
				addCell(playerTable, j, newColCurrLvl, newCurrLvl + "(" + diffLvl + ")", "", "right", "", 50);
				addCell(playerTable, j, newColAwpDiff, awp - getAWPsOfLevel(newCurrLvl+1), "", "right", "", 70);
				if(newColNextLvl)
				{
					addCell(playerTable, j, newColNextLvl, (newCurrLvl+1) + " (" + getAWPsOfLevel(newCurrLvl+1) + ")", "", "right", "", 70);
				}				
			} else {
				// This case was added for the last line in the table "Team". Otherwise no new columns would be added there!
				addCell(playerTable, j, newColCurrLvl, "", "", "right", "#76a898", "");
				addCell(playerTable, j, newColAwpDiff, "", "", "right", "#76a898", "");
				addCell(playerTable, j, newColNextLvl, "", "", "right", "#76a898", "");
			}
		} catch (e) {			
			exceptionHandler(e);
		}
	}	
}

var strengthPoints=new Array(
'0','226','329','446','625','911','1.298','1.793','2.421','3.225','4.146','5.041','5.997','7.129','8.473','9.925','11.379','12.717','13.694','14.555','15.440','15.873','16.679','17.470'
);
